<?php

namespace dgsoft\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCorporateSetting ArrayType
 * @package Dg
 * @subpackage Arrays
 */
class DgArrayOfCorporateSetting extends AbstractStructArrayBase
{
    /**
     * The CorporateSetting
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \dgsoft\StructType\DgCorporateSetting[]
     */
    public $CorporateSetting;
    /**
     * Constructor method for ArrayOfCorporateSetting
     * @uses DgArrayOfCorporateSetting::setCorporateSetting()
     * @param \dgsoft\StructType\DgCorporateSetting[] $corporateSetting
     */
    public function __construct(array $corporateSetting = array())
    {
        $this
            ->setCorporateSetting($corporateSetting);
    }
    /**
     * Get CorporateSetting value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \dgsoft\StructType\DgCorporateSetting[]|null
     */
    public function getCorporateSetting()
    {
        return isset($this->CorporateSetting) ? $this->CorporateSetting : null;
    }
    /**
     * Set CorporateSetting value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCorporateSetting[] $corporateSetting
     * @return \dgsoft\ArrayType\DgArrayOfCorporateSetting
     */
    public function setCorporateSetting(array $corporateSetting = array())
    {
        foreach ($corporateSetting as $arrayOfCorporateSettingCorporateSettingItem) {
            // validation for constraint: itemType
            if (!$arrayOfCorporateSettingCorporateSettingItem instanceof \dgsoft\StructType\DgCorporateSetting) {
                throw new \InvalidArgumentException(sprintf('The CorporateSetting property can only contain items of \dgsoft\StructType\DgCorporateSetting, "%s" given', is_object($arrayOfCorporateSettingCorporateSettingItem) ? get_class($arrayOfCorporateSettingCorporateSettingItem) : gettype($arrayOfCorporateSettingCorporateSettingItem)), __LINE__);
            }
        }
        if (is_null($corporateSetting) || (is_array($corporateSetting) && empty($corporateSetting))) {
            unset($this->CorporateSetting);
        } else {
            $this->CorporateSetting = $corporateSetting;
        }
        return $this;
    }
    /**
     * Add item to CorporateSetting value
     * @throws \InvalidArgumentException
     * @param \dgsoft\StructType\DgCorporateSetting $item
     * @return \dgsoft\ArrayType\DgArrayOfCorporateSetting
     */
    public function addToCorporateSetting(\dgsoft\StructType\DgCorporateSetting $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \dgsoft\StructType\DgCorporateSetting) {
            throw new \InvalidArgumentException(sprintf('The CorporateSetting property can only contain items of \dgsoft\StructType\DgCorporateSetting, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->CorporateSetting[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \dgsoft\StructType\DgCorporateSetting|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \dgsoft\StructType\DgCorporateSetting|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \dgsoft\StructType\DgCorporateSetting|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \dgsoft\StructType\DgCorporateSetting|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \dgsoft\StructType\DgCorporateSetting|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CorporateSetting
     */
    public function getAttributeName()
    {
        return 'CorporateSetting';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\ArrayType\DgArrayOfCorporateSetting
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
